unit uEditor;

//******************************************************************************
// V tto jednotce se nachzej procedury obsluhujc udlosti spojen s ovld-
// nm grafickho uivatelskho rozhran modulu.
//******************************************************************************


interface

//******************************************************************************
// Jednotky DAudioEffectX, DVstTemplate, DAEffectX a DVstUtils pouit v mnoi-
// n uses jsou soust ablony VST SDK firmy steinberg, peloen do jazyka
// Delphi, ped peloenm je tedy nutn nastavit v prosted Delphi cestu k ad-
// resi CommonVST, ve kterm se nachzej
// (v menu Tools/Enviroment Options/Library/Library path.
//******************************************************************************

uses Windows, Forms, DAudioEffectX, Messages, ExtCtrls,
     Classes, Graphics, StdCtrls, Controls,
     DVstTemplate, DAEffectX, DVstUtils, Menus, Buttons, jpeg, ComCtrls;

//******************************************************************************
// Tda TPluginEditorWindow pedstavuje hlavn formul - okno modulu VSTunel.
//******************************************************************************

type
  TPluginEditorWindow = class(TForm)
    Ctrl: TLabel;
    Updater: TTimer;
    par0: TScrollBar;
    Label3: TLabel;
    Label4: TLabel;
    Label1: TLabel;
    EnablePar0: TCheckBox;
    Label2: TLabel;
    Description: TLabel;
    Image1: TImage;
    Label6: TLabel;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    EnablePar1: TCheckBox;
    EnablePar4: TCheckBox;
    Label5: TLabel;
    Label7: TLabel;
    EnablePar5: TCheckBox;
    EnablePar6: TCheckBox;
    EnablePar7: TCheckBox;
    par1: TScrollBar;
    Label8: TLabel;
    UpDown1: TUpDown;
    Label9: TLabel;
    UpDown2: TUpDown;
    Label10: TLabel;
    UpDown3: TUpDown;
    Label11: TLabel;
    UpDown4: TUpDown;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label24: TLabel;
    EnablePar2: TCheckBox;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Label25: TLabel;
    EnablePar3: TCheckBox;
    UpDown5: TUpDown;
    UpDown6: TUpDown;
    UpDown7: TUpDown;
    UpDown8: TUpDown;
    Button1: TButton;
    procedure UpdaterTimer(Sender: TObject);
    procedure par0Change(Sender: TObject);
    procedure par1Change(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown3Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown4Click(Sender: TObject; Button: TUDBtnType);
    procedure EnablePar4Click(Sender: TObject);
    procedure Image3Click(Sender: TObject);
    procedure Image4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure UpDown8Click(Sender: TObject; Button: TUDBtnType);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FEffect: TVstTemplate;
  public
    manually: boolean;      // Pznak zabraujc nekonenm cyklm aktualizac
    fPar: array of single;
    property Effect: TVstTemplate read FEffect write FEffect;
  private
    procedure OnEditorOpen(var Msg: TMessage); message WM_EDITOROPEN;
  end;

implementation
uses sysutils, uplugin;
{$R *.DFM}

//******************************************************************************
// Metoda TPluginEditorWindow.pUpdaterTimer zpsob odpovdajc zmnu
// grafickho ovldacho prvku (zde ScrollBar) Pznak manually zabrauje
// nekonenmu cyklu (zmena parametru -> zmna ovldacho prvku -> zmena
// parametru ->...) Tato zmna se provede, jen pokud se zmnila hodnota
// parametru, ktermu grafick ovldac prvek odpovd (pznak
// editorNeedsUpdate). Dle jsou zde provedena znepstupnn ovldacch prvk
// v zvislosti na zakrtnutch polcch "povolit" ("enable").
//******************************************************************************

procedure TPluginEditorWindow.UpdaterTimer(Sender: TObject);
var j: integer;
begin
 if (not assigned(Effect)) or(not Effect.editorNeedsUpdate) then exit;
 manually := true;

 with Effect do
 begin
  j := round(getParameter(0) * 100);
  if j <> par0.position then par0.position := j;
  j := round(getParameter(1) * 100);
  if j <> par1.position then par1.position := j;
  j := round(getParameterEx(2));
  if j <> UpDown5.position then UpDown5.position := j;
  j := round(getParameterEx(3));
  if j <> UpDown6.position then UpDown6.position := j;
  j := round(getParameterEx(4));
  if j <> UpDown7.position then UpDown7.position := j;
  j := round(getParameterEx(5));
  if j <> UpDown8.position then UpDown8.position := j;

 end;

 if not EnablePar0.Checked then par0.enabled:=False else par0.enabled:=True;
 if not EnablePar1.Checked then par1.enabled:=False else par1.enabled:=True;
 if not EnablePar4.Checked then UpDown5.enabled:=False else UpDown5.enabled:=True;
 if not EnablePar5.Checked then UpDown6.enabled:=False else UpDown6.enabled:=True;
 if not EnablePar6.Checked then UpDown7.enabled:=False else UpDown7.enabled:=True;
 if not EnablePar7.Checked then UpDown8.enabled:=False else UpDown8.enabled:=True;
 if not EnablePar2.Checked then begin
                               BitBtn1.Enabled:=False;
                               BitBtn2.Enabled:=False;
                               end else begin
                                        if Effect.getParameterEx(6)=0
                                           then BitBtn1.Enabled:=True
                                           else BitBtn2.Enabled:=True;
                                        end;
 if not EnablePar3.Checked then begin
                               BitBtn3.Enabled:=False;
                               BitBtn4.Enabled:=False;
                               end else begin
                                        if Effect.getParameterEx(7)=0
                                           then BitBtn3.Enabled:=True
                                           else BitBtn4.Enabled:=True;
                                        end;


 manually := false;
 Effect.editorNeedsUpdate := false;
end;

//******************************************************************************
// Metody par0Change a par1Change zpsob odpovdajc zmnu parametru
// na zklad zmny grafickho ovldacho prvku (zde TScrollbar). Pznak
// manually zabrauje nekonenmu cyklu (zmna ovldacho prvku -> zmena para-
// metru -> zmna ovldacho prvku -> ...)
//******************************************************************************

procedure TPluginEditorWindow.par0Change(Sender: TObject);
begin
 if manually then exit;
 if assigned(effect) then
  Effect.setParameterAutomated((Sender as TScrollbar).Tag,
   (Sender as TScrollbar).Position / 100);
end;

procedure TPluginEditorWindow.par1Change(Sender: TObject);
begin
 if manually then exit;
 if assigned(effect) then
  Effect.setParameterAutomated((Sender as TScrollbar).Tag,
   (Sender as TScrollbar).Position / 100);
end;

//******************************************************************************
// Metoda TPluginEditorWindow.OnEditorOpen je volna vdy pi otevrn okna
// editoru, je tedy vhodn zajistit v n sprvn nastaven ovldacch prvk.
//******************************************************************************

procedure TPluginEditorWindow.OnEditorOpen(var Msg: TMessage);
begin
 Effect := TVstTemplate(Msg.WParam);
 if assigned(effect) then Effect.editorNeedsUpdate:=True;
end;

//******************************************************************************
// Procedury TPluginEditorWindow.UpDown1Click - UpDown4Click obsluhuj nastaven
// velikosti kroku, jakm se bude mnit hodnota parametr ovldanch hlavnmi
// (velkmi) tlatky UpDown.
//******************************************************************************

procedure TPluginEditorWindow.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
Label12.Caption:=IntToStr(UpDown1.Position);
UpDown5.Increment:=UpDown1.Position;
end;

procedure TPluginEditorWindow.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
Label13.Caption:=IntToStr(UpDown2.Position);
UpDown6.Increment:=UpDown2.Position;
end;

procedure TPluginEditorWindow.UpDown3Click(Sender: TObject; Button: TUDBtnType);
begin
Label14.Caption:=IntToStr(UpDown3.Position);
UpDown7.Increment:=UpDown3.Position;
end;

procedure TPluginEditorWindow.UpDown4Click(Sender: TObject; Button: TUDBtnType);
begin
Label15.Caption:=IntToStr(UpDown4.Position);
UpDown8.Increment:=UpDown4.Position;
end;

//******************************************************************************
// Procedura TPluginEditorWindow.EnablePar3Click zajiuje znepstupnn ovlda-
// cch prvk editoru.
//******************************************************************************

procedure TPluginEditorWindow.EnablePar4Click(Sender: TObject);
begin
if assigned(effect) then
   Effect.editorNeedsUpdate:=True;
end;

//******************************************************************************
// Procedura TPluginEditorWindow.Image3Click zmn jazyk popisk uivatelskho
// prosted programu na anglitinu.
//******************************************************************************

procedure TPluginEditorWindow.Image3Click(Sender: TObject);
begin
Description.Caption:=
'VST is a trademark of Steinberg Media Technologies GmbH'+#13#10+
'VST SDK Delphi translation by Frederic Vanmol (www.axiworld.be)'+#13#10+
'VST Template code by Tobias Fleischer/Tobybear (www.tobybear.de)';
Label6.Caption:='Created by Jan Valendin, 2006, freeware.';
Label3.Caption:='TRANSPOSE: ';
Label4.Caption:='VELOCITY SHIFT ';
Label1.Caption:='PARAMETER 1';
Label2.Caption:='PARAMETER 2';
Label5.Caption:='PARAMETER 3';
Label7.Caption:='PARAMETER 4';
Label24.Caption:='SWITCH 1';
Label25.Caption:='SWITCH 2';
Label8.Caption:='step: ';
Label9.Caption:='step: ';
Label10.Caption:='step: ';
Label11.Caption:='step: ';
EnablePar0.Caption:='enable';
EnablePar1.Caption:='enable';
EnablePar2.Caption:='enable';
EnablePar3.Caption:='enable';
EnablePar4.Caption:='enable';
EnablePar5.Caption:='enable';
EnablePar6.Caption:='enable';
EnablePar7.Caption:='enable';
BitBtn1.Caption:='ON';
BitBtn2.Caption:='OFF';
BitBtn3.Caption:='ON';
BitBtn4.Caption:='OFF';
Button1.Caption:='PANIC!';
end;

//******************************************************************************
// Procedura TPluginEditorWindow.Image4Click zmn jazyk popisk uivatelskho
// prosted programu na etinu.
//******************************************************************************

procedure TPluginEditorWindow.Image4Click(Sender: TObject);
begin
Description.Caption:=
'VST je registrovan obchodn znmka Steinberg Media Technologies GmbH'+#13#10+
'VST SDK do Delphi peloil Frederic Vanmol (www.axiworld.be)'+#13#10+
'ablonu VST Template vytvoil Tobias Fleischer/Tobybear (www.tobybear.de)';
Label6.Caption:='Vytvoil Jan Valendin, 2006, voln iteln.';
Label3.Caption:='TRANSPOZICE';
Label4.Caption:='HOZOV RYCH';
Label1.Caption:='PARAMETR 1';
Label2.Caption:='PARAMETR 2';
Label5.Caption:='PARAMETR 3';
Label7.Caption:='PARAMETR 4';
Label8.Caption:='krok: ';
Label9.Caption:='krok: ';
Label10.Caption:='krok: ';
Label11.Caption:='krok: ';
Label24.Caption:='PEPNA 1 ';
Label25.Caption:='PEPNA 2 ';
EnablePar0.Caption:='povolit';
EnablePar1.Caption:='povolit';
EnablePar2.Caption:='povolit';
EnablePar3.Caption:='povolit';
EnablePar4.Caption:='povolit';
EnablePar5.Caption:='povolit';
EnablePar6.Caption:='povolit';
EnablePar7.Caption:='povolit';
BitBtn1.Caption:='ZAP';
BitBtn2.Caption:='VYP';
BitBtn3.Caption:='ZAP';
BitBtn4.Caption:='VYP';
Button1.Caption:='VYPNOUT!';
end;

//******************************************************************************
// Nsledujc tyi procedury BitBtn1Click - BitBtn4Click obsluhuj ovldn
// tlatek pro pepnn hodnoty parametr, u kterch se uvauj jen dv hodno-
// ty - zapnuto a vypnuto.
//******************************************************************************

procedure TPluginEditorWindow.BitBtn1Click(Sender: TObject);
begin
if assigned(effect) then
   begin
   Effect.setParameterEx((Sender as TButton).Tag,127);
   BitBtn1.Enabled:=False;
   BitBtn2.Enabled:=True;
   end;
end;

procedure TPluginEditorWindow.BitBtn2Click(Sender: TObject);
begin
if assigned(effect) then
   begin
   Effect.setParameterEx((Sender as TButton).Tag,0);
   BitBtn1.Enabled:=True;
   BitBtn2.Enabled:=False;
   end;
end;

procedure TPluginEditorWindow.BitBtn3Click(Sender: TObject);
begin
if assigned(effect) then
   begin
   Effect.setParameterEx((Sender as TButton).Tag,127);
   BitBtn3.Enabled:=False;
   BitBtn4.Enabled:=True;
   end;
end;

procedure TPluginEditorWindow.BitBtn4Click(Sender: TObject);
begin
if assigned(effect) then
   begin
   Effect.setParameterEx((Sender as TButton).Tag,0);
   BitBtn4.Enabled:=False;
   BitBtn3.Enabled:=True;
  end;
end;

//******************************************************************************
// Procedura TPluginEditorWindow.UpDown8Click obsluhuje zmnu hodnot parametr
// ovldanou hlavnmi (velkmi) tlatky typu UpDown. Konkrtn parametr, kter
// uivatel mn, se rozpoznv podle tagu stisknutho tlatka.
//******************************************************************************

procedure TPluginEditorWindow.UpDown8Click(Sender: TObject;
  Button: TUDBtnType);
begin
if assigned(effect) then Effect.setParameterEx((Sender as TUpDown).Tag,
                                               (Sender as TUpDown).Position);
end;

procedure TPluginEditorWindow.FormShow(Sender: TObject);
begin
if assigned(effect) then Effect.editorNeedsUpdate:=True;
end;

//******************************************************************************
// Procedura TPluginEditorWindow.Button1Click spout odesln skupiny zprv
// MIDI typu "Uvolnn klvesy" - nouzov zastav pehrvn.
//******************************************************************************

procedure TPluginEditorWindow.Button1Click(Sender: TObject);
begin
if assigned(effect) then
   if (Effect.getParameterEx(8)=127) then Effect.setParameterEx(8,0)
end;

end.

